=== debian/changelog ===
fenics-dolfinx (1:0.10.0.post5-5) unstable; urgency=medium

  * add powerpc to SKIP_NONLINEAR_PDE_TEST_ARCH_LIST to skip
    test_nonlinear_pde, and also skip
    test_compare_solution_linear_vs_nonlinear_problem
  * fix test skips for bigendian arches (append, don't replace)

 -- Drew Parsons <dparsons@debian.org>  Sun, 01 Feb 2026 13:46:57 +0100

fenics-dolfinx (1:0.10.0.post5-4) unstable; urgency=medium

  * update python-dolfinx Breaks: python3-dolfinx-mpc (<< 0.10~)

 -- Drew Parsons <dparsons@debian.org>  Fri, 02 Jan 2026 12:29:48 +1100

fenics-dolfinx (1:0.10.0.post5-3) unstable; urgency=medium

  * libdolfinx-dev  Breaks: fenicsx-performance-tests-source (<< 0.10~)
    python3-dolfinx Breaks: python3-scifem (<< 0.14~)
  * Standards-Version: 4.7.3

 -- Drew Parsons <dparsons@debian.org>  Mon, 29 Dec 2025 10:23:26 +1100

fenics-dolfinx (1:0.10.0.post5-2) unstable; urgency=medium

  * debian/tests: test-dolfinx-python-demos skip
    demo_scattering_boundary_conditions on i386 with complex numbers
    (vtk 9.5 pushes i386 over its 32-bit memory limit)

 -- Drew Parsons <dparsons@debian.org>  Mon, 22 Dec 2025 23:49:42 +0100

fenics-dolfinx (1:0.10.0.post5-1) unstable; urgency=medium

  * New upstream 0.10 post release
    - applies debian patches fix_partitioner_ghost_PR4003.patch
      fix_scotch_partitioner_PR4001.patch,
      py314_refcount_bunkab84c39.patch
  * update versioned Depends: python3-ffcx (>= 1:0.10.1~),
    python3-ufl (>= 2025.2.0~)

 -- Drew Parsons <dparsons@debian.org>  Sun, 21 Dec 2025 10:36:39 +0100
